/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.nutch.metadata;


/**
 * A collection of <i>"Office"</i> documents properties names.
 *
 * @author Chris Mattmann
 * @author J&eacute;r&ocirc;me Charron
 */
public interface Office {
    
  public static final String KEYWORDS = "Keywords";
  
  public static final String COMMENTS = "Comments";
  
  public static final String LAST_AUTHOR = "Last-Author";
  
  public static final String APPLICATION_NAME = "Application-Name";
  
  public static final String CHARACTER_COUNT = "Character Count";
  
  public static final String LAST_PRINTED = "Last-Printed";
  
  public static final String LAST_SAVED = "Last-Save-Date";
  
  public static final String PAGE_COUNT = "Page-Count";
  
  public static final String REVISION_NUMBER = "Revision-Number";
  
  public static final String WORD_COUNT = "Word-Count";
  
  public static final String TEMPLATE = "Template";
  
  public static final String AUTHOR = "Author";
  
}
